# Copyright (c) 2000-2013, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define section free
%define _binary_payload w9.gzdio
%define _source_payload w9.gzdio
%define _binary_filedigest_algorithm 1
%define _source_filedigest_algorithm 1

Name:           tuscany-sdo-java
Version:        1.1.1
Release:        2%{?dist}
Epoch:          0
Summary:        Apache Tuscany Service Data Objects
License:        ASL 2.0
Group:          Text Processing/Markup/XML
URL:            http://tuscany.apache.org
# svn export http://svn.apache.org/repos/asf/tuscany/sdo-java/tags/1.1.1/ tuscany-sdo-java-1.1.1
# tar czf tuscany-sdo-java-1.1.1.tgz tuscany-sdo-java-1.1.1/

Source0:        tuscany-sdo-java-1.1.1.tgz
Source1:        %{name}-settings.xml
Source2:        %{name}-jpp-depmap.xml
Source3:        tuscany-parent.pom 
# http://svn.apache.org/repos/asf/tuscany/java/pom/parent/pom.xml
#Source4:        http://repo1.maven.org/maven2/org/apache/tuscany/sdo/tuscany-sdo/1.1.1/tuscany-sdo-1.1.1.pom
Source5:        eclipse-temp.tgz
Patch0:         tuscany-sdo-java-StreamDeserializer.patch
Patch1:         tuscany-sdo-java-SDODeserializer.patch
Patch2:         tuscany-sdo-java-OSGiTestCase.patch
Patch3:         tuscany-sdo-java-plugin-pom.patch
Patch4:         tuscany-sdo-java-sample-pom.patch

Requires(post): jpackage-utils
Requires(postun): jpackage-utils
Requires:       jpackage-utils >= 0:1.7.5
Requires:       java >= 0:1.6.0
BuildRequires:  jpackage-utils >= 0:1.7.5
BuildRequires:  java-devel >= 0:1.6.0
BuildRequires:  ant
BuildRequires:  junit >= 0:3.8.2
BuildRequires:  wstx
BuildRequires:  xstream
BuildRequires:  apache-commons-parent
BuildRequires:  maven-bundle-plugin
BuildRequires:  maven2 >= 2.0.8
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-release
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven-surefire-maven-plugin
BuildRequires:  maven-surefire-provider-junit
BuildRequires:  apache-felix-maven-bundle-plugin
BuildRequires:  apache-felix-main
BuildRequires:  servlet_2_5_api
BuildRequires:  stax_1_0_api
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
SOA creates an environment where different types of data 
must work together. This makes application development 
complex. Service Data Object(SDO), provides a very simple 
programming model that addresses this issue. The key high 
level advantages of SDO are:
* Uniform access to data from heterogeneous sources which 
  could be XML, RDB, POJO, SOAP, etc.
* SDO provides both a static (or strongly typed) programming
  model and a dynamic (or loosely typed) programming model. 
  This provides a simple programming model without sacrificing
  the dynamic model needed by tools and frameworks.
* Provides Meta-data for easy introspection of data types
* Supports a disconnected model, whereby data can be retrieved 
  from a data source via Data Access Service. The data can be 
  modified by a client with change tracking, and applied back 
  to the data source.
* SDO programming model is language neutral

Tuscany SDO Java implements SDO 2.1 specification and is 
complemented with utility APIs that further extend the 
functionality.
The project's code base includes the following:
* Dynamic data object support
* Static code generation (recently updated to remove the 
  externalised EMF dependency aspects)
* Scoping of Types using XMLHelper, XSDHelper, DataFactory, 
  CopyHelper, EqualityHelper implementations.
* ChangeSummary support for both the DataGraphs and DataObjects
* Example programs
Tuscany provides a relational data access service (RDB DAS) that 
works with SDO Java. More DAS implementations are underway.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
%{summary}.

%prep
%setup -q
%patch0 -p0 -b .sav0
%patch1 -p0 -b .sav1
%patch2 -p0 -b .sav2
%patch3 -p0 -b .sav3
%patch4 -p0 -b .sav4

for p in $(find . -name pom.xml); do
    sed -i -e 's|-incubating||' $p
done

%{__cp} -p %{SOURCE1} settings.xml

%{__sed} -i -e "s|<url>__JPP_URL_PLACEHOLDER__</url>|<url>file://`pwd`/.m2/repository</url>|g" settings.xml
%{__sed} -i -e "s|<url>__JAVADIR_PLACEHOLDER__</url>|<url>file://`pwd`/external_repo</url>|g" settings.xml
%{__sed} -i -e "s|<url>__MAVENREPO_DIR_PLACEHOLDER__</url>|<url>file://`pwd`/.m2/repository</url>|g" settings.xml
%{__sed} -i -e "s|<url>__MAVENDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/maven2/plugins</url>|g" settings.xml
%{__sed} -i -e "s|<url>__ECLIPSEDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/eclipse/plugins</url>|g" settings.xml

mkdir external_repo
%{__ln_s} %{_javadir} external_repo/JPP

%build
export MAVEN_OPTS="-Xmx768m -XX:MaxPermSize=128m"
export MAVEN_REPO_LOCAL=$(pwd)/.m2/repository
%{__mkdir_p} ${MAVEN_REPO_LOCAL}/org/apache/tuscany/parent/2/
%{__cp} %{SOURCE3} ${MAVEN_REPO_LOCAL}/org/apache/tuscany/parent/2/parent-2.pom
#%{__mkdir_p} ${MAVEN_REPO_LOCAL}/org/apache/tuscany/sdo/tuscany-sdo/1.1/
#%{__cp} %{SOURCE4} ${MAVEN_REPO_LOCAL}/org/apache/tuscany/sdo/tuscany-sdo/1.1/tuscany-sdo-1.1.pom
%if 0
%{__mkdir_p} ${MAVEN_REPO_LOCAL}/org/eclipse/emf/ecore/2.2.3/
%{__ln_s} /usr/share/eclipse/dropins/emf/eclipse/plugins/org.eclipse.emf.ecore_2.*.jar ${MAVEN_REPO_LOCAL}/org/eclipse/emf/ecore/2.2.3/ecore-2.2.3.jar
%{__mkdir_p} ${MAVEN_REPO_LOCAL}/org/eclipse/emf/common/2.2.3/
%{__ln_s} /usr/share/eclipse/dropins/emf/eclipse/plugins/org.eclipse.emf.common_2.*.jar ${MAVEN_REPO_LOCAL}/org/eclipse/emf/common/2.2.3/common-2.2.3.jar
%{__mkdir_p} ${MAVEN_REPO_LOCAL}/org/eclipse/emf/ecore-change/2.2.3/
%{__ln_s} /usr/share/eclipse/dropins/emf/eclipse/plugins/org.eclipse.emf.ecore.change_2.*.jar ${MAVEN_REPO_LOCAL}/org/eclipse/emf/ecore-change/2.2.3/ecore-change-2.2.3.jar
%{__mkdir_p} ${MAVEN_REPO_LOCAL}/org/eclipse/emf/ecore-xmi/2.2.3/
%{__ln_s} /usr/share/eclipse/dropins/emf/eclipse/plugins/org.eclipse.emf.ecore.xmi_2.*.jar ${MAVEN_REPO_LOCAL}/org/eclipse/emf/ecore-xmi/2.2.3/ecore-xmi-2.2.3.jar
%{__mkdir_p} ${MAVEN_REPO_LOCAL}/org/eclipse/xsd/xsd/2.2.3/
%{__ln_s} /usr/share/eclipse/dropins/xsd/eclipse/plugins/org.eclipse.xsd_2.*.jar ${MAVEN_REPO_LOCAL}/org/eclipse/xsd/xsd/2.2.3/xsd-2.2.3.jar
%{__mkdir_p} ${MAVEN_REPO_LOCAL}/org/eclipse/emf/codegen/2.2.3/
%{__ln_s} /usr/share/eclipse/dropins/emf/eclipse/plugins/org.eclipse.emf.codegen_2.*.jar ${MAVEN_REPO_LOCAL}/org/eclipse/emf/codegen/2.2.3/codegen-2.2.3.jar
%{__mkdir_p} ${MAVEN_REPO_LOCAL}/org/eclipse/emf/codegen-ecore/2.2.3/
%{__ln_s} /usr/share/eclipse/dropins/emf/eclipse/plugins/org.eclipse.emf.codegen.ecore_2.*.jar ${MAVEN_REPO_LOCAL}/org/eclipse/emf/codegen-ecore/2.2.3/codegen-ecore-2.2.3.jar
%else
tar xzf %{SOURCE5}
%endif
%{_bindir}/mvn-jpp \
        -e \
        -s $(pwd)/settings.xml \
        -Dmaven2.jpp.depmap.file=%{SOURCE2} \
        -Dmaven.repo.local=${MAVEN_REPO_LOCAL} \
        -Dmaven.test.failure.ignore=true \
        install 

%{_bindir}/mvn-jpp \
        -e \
        -s $(pwd)/settings.xml \
        -Dmaven2.jpp.depmap.file=%{SOURCE2} \
        -Dmaven.repo.local=${MAVEN_REPO_LOCAL} \
        javadoc:aggregate

%install
%{__rm} -rf %{buildroot}

%{__mkdir_p} %{buildroot}%{_javadir}/tuscany
%{__cp} -p sdo-api/target/tuscany-sdo-api-r2.1-%{version}.jar %{buildroot}%{_javadir}/tuscany/sdo-api-r2.1-%{version}.jar
%{__cp} -p impl/target/tuscany-sdo-impl-%{version}.jar %{buildroot}%{_javadir}/tuscany/sdo-impl-%{version}.jar
%{__cp} -p lib/target/tuscany-sdo-lib-%{version}.jar %{buildroot}%{_javadir}/tuscany/sdo-lib-%{version}.jar
%{__cp} -p tools/target/tuscany-sdo-tools-%{version}.jar %{buildroot}%{_javadir}/tuscany/sdo-tools-%{version}.jar
%{__cp} -p java5tools/target/tuscany-sdo-java5tools-%{version}.jar %{buildroot}%{_javadir}/tuscany/sdo-java5tools-%{version}.jar
%{__cp} -p plugin/target/tuscany-sdo-plugin-%{version}.jar %{buildroot}%{_javadir}/tuscany/sdo-plugin-%{version}.jar

(cd %{buildroot}%{_javadir}/tuscany && for jar in *-%{version}*; do %{__ln_s} ${jar} ${jar/-%{version}/}; done)

# poms
%{__mkdir_p} %{buildroot}%{_datadir}/maven2/poms
%{__cp} -p pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP.tuscany-sdo.pom
%add_to_maven_depmap org.apache.tuscany.sdo tuscany-sdo %{version} JPP/tuscany sdo
%{__cp} -p sdo-api/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP.tuscany-sdo-api-r2.1.pom
%add_to_maven_depmap org.apache.tuscany.sdo tuscany-sdo-api-r2.1 %{version} JPP/tuscany sdo-api-r2.1
%{__cp} -p impl/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP.tuscany-sdo-impl.pom
%add_to_maven_depmap org.apache.tuscany.sdo tuscany-sdo-impl %{version} JPP/tuscany sdo-impl
%{__cp} -p lib/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP.tuscany-sdo-lib.pom
%add_to_maven_depmap org.apache.tuscany.sdo tuscany-sdo-lib %{version} JPP/tuscany sdo-lib
%{__cp} -p tools/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP.tuscany-sdo-tools.pom
%add_to_maven_depmap org.apache.tuscany.sdo tuscany-sdo-tools %{version} JPP/tuscany sdo-tools
%{__cp} -p java5tools/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP.tuscany-sdo-java5tools.pom
%add_to_maven_depmap org.apache.tuscany.sdo tuscany-sdo-java5tools %{version} JPP/tuscany sdo-java5tools
%{__cp} -p plugin/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP.tuscany-sdo-plugin.pom
%add_to_maven_depmap org.apache.tuscany.sdo tuscany-sdo-plugin %{version} JPP/tuscany sdo-plugin
%{__cp} -p %{SOURCE3} %{buildroot}%{_datadir}/maven2/poms/JPP.tuscany-parent.pom
%add_to_maven_depmap org.apache.tuscany parent %{version} JPP/tuscany parent


# javadoc
%{__mkdir_p} %{buildroot}%{_javadocdir}/%{name}-%{version}
%{__cp} -pr target/site/apidocs/* %{buildroot}%{_javadocdir}/%{name}-%{version}/
%{__ln_s} %{name}-%{version} %{buildroot}%{_javadocdir}/%{name}

%clean
%{__rm} -rf %{buildroot}

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%dir %{_javadir}/tuscany
%{_javadir}/tuscany/*.jar
%{_datadir}/maven2/poms/*
%{_mavendepmapfragdir}/*

%files javadoc
%defattr(0644,root,root,0755)
%doc %{_javadocdir}/%{name}-%{version}
%doc %{_javadocdir}/%{name}

%changelog
* Tue Feb 05 2013 Ralph Apel <r.apel@r-apel.de> 0:1.1.1-2
- Prevent xzpayload problem

* Sat Jan 12 2013 Ralph Apel <r.apel@r-apel.de> 0:1.1.1-1
- 1.1.1

